Package org.jboss.resteasy.client.jaxrs.internal

## Class ResteasyClientBuilderImpl

- java.lang.Object
- - javax.ws.rs.client.ClientBuilder
  - - org.jboss.resteasy.client.jaxrs.ResteasyClientBuilder
    - - org.jboss.resteasy.client.jaxrs.internal.ResteasyClientBuilderImpl

- All Implemented Interfaces:
    `javax.ws.rs.core.Configurable<javax.ws.rs.client.ClientBuilder>`

      public class ResteasyClientBuilderImpl
      extends ResteasyClientBuilder

  Abstraction for creating Clients. Allows SSL configuration. Uses Apache Http Client under the covers. If used with other ClientHttpEngines though, all configuration options are ignored.
  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.jboss.resteasy.client.jaxrs.ResteasyClientBuilder

      `ResteasyClientBuilder.HostnameVerificationPolicy`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected ExecutorService` | `asyncExecutor` |
    `protected boolean` | `cleanupExecutor` |
    `protected KeyStore` | `clientKeyStore` |
    `protected String` | `clientPrivateKeyPassword` |
    `protected int` | `connectionCheckoutTimeoutMs` |
    `protected int` | `connectionPoolSize` |
    `protected long` | `connectionTTL` |
    `protected TimeUnit` | `connectionTTLUnit` |
    `protected boolean` | `cookieManagementEnabled` |
    `protected org.apache.http.HttpHost` | `defaultProxy` |
    `protected boolean` | `disableAutomaticRetries` |
    `protected boolean` | `disableTrustManager` |
    `protected long` | `establishConnectionTimeout` |
    `protected TimeUnit` | `establishConnectionTimeoutUnits` |
    `protected boolean` | `followRedirects` |
    `protected ClientHttpEngine` | `httpEngine` |
    `protected int` | `maxPooledPerRoute` |
    `protected ResteasyClientBuilder.HostnameVerificationPolicy` | `policy` |
    `protected Map<String,​Object>` | `properties` |
    `protected ResteasyProviderFactory` | `providerFactory` |
    `protected int` | `responseBufferSize` |
    `protected ScheduledExecutorService` | `scheduledExecutorService` |
    `protected List<String>` | `sniHostNames` |
    `protected long` | `socketTimeout` |
    `protected TimeUnit` | `socketTimeoutUnits` |
    `protected SSLContext` | `sslContext` |
    `protected boolean` | `trustSelfSignedCertificates` |
    `protected KeyStore` | `truststore` |
    `protected HostnameVerifier` | `verifier` |

    - ### Fields inherited from class org.jboss.resteasy.client.jaxrs.ResteasyClientBuilder

      `PROPERTY_PROXY_HOST, PROPERTY_PROXY_PORT, PROPERTY_PROXY_SCHEME`

    - ### Fields inherited from class javax.ws.rs.client.ClientBuilder

      `JAXRS_DEFAULT_CLIENT_BUILDER_PROPERTY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ResteasyClientBuilderImpl()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ResteasyClientBuilderImpl` | `asyncExecutor​(ExecutorService asyncExecutor)` | Deprecated. use `executorService(ExecutorService)` instead
    `ResteasyClientBuilderImpl` | `asyncExecutor​(ExecutorService asyncExecutor, boolean cleanupExecutor)` | Deprecated.
    `ResteasyClient` | `build()` |
    `ResteasyClientBuilderImpl` | `connectionCheckoutTimeout​(long timeout, TimeUnit unit)` | If connection pooling is enabled, how long will we wait to get a connection?
    `ResteasyClientBuilderImpl` | `connectionPoolSize​(int connectionPoolSize)` | Number of connections allowed to pool.
    `ResteasyClientBuilderImpl` | `connectionTTL​(long ttl, TimeUnit unit)` | If there is a connection pool, set the time to live in the pool.
    `ResteasyClientBuilderImpl` | `connectTimeout​(long timeout, TimeUnit unit)` |
    `protected ResteasyClient` | `createResteasyClient​(ClientHttpEngine engine, ExecutorService executor, boolean cleanupExecutor, ScheduledExecutorService scheduledExecutorService, ClientConfiguration config)` |
    `ResteasyClientBuilderImpl` | `defaultProxy​(String hostname)` | Specify a default proxy.
    `ResteasyClientBuilderImpl` | `defaultProxy​(String hostname, int port)` | Specify a default proxy host and port.
    `ResteasyClientBuilderImpl` | `defaultProxy​(String hostname, int port, String scheme)` | Specify default proxy.
    `ResteasyClientBuilder` | `disableAutomaticRetries()` | boolean, notify apache to disable its automatic retries.
    `ResteasyClientBuilderImpl` | `disableTrustManager()` | Disable trust management and hostname verification.
    `ResteasyClientBuilder` | `enableCookieManagement()` | Enable state (cookie) management.
    `ResteasyClientBuilder` | `executorService​(ExecutorService executorService)` |
    `ResteasyClientBuilder` | `executorService​(ExecutorService executorService, boolean cleanupExecutor)` |
    `javax.ws.rs.core.Configuration` | `getConfiguration()` |
    `long` | `getConnectionCheckoutTimeout​(TimeUnit unit)` |
    `int` | `getConnectionPoolSize()` |
    `long` | `getConnectionTimeout​(TimeUnit unit)` |
    `long` | `getConnectionTTL​(TimeUnit unit)` |
    `String` | `getDefaultProxyHostname()` |
    `int` | `getDefaultProxyPort()` |
    `String` | `getDefaultProxyScheme()` |
    `ResteasyClientBuilder.HostnameVerificationPolicy` | `getHostnameVerification()` |
    `HostnameVerifier` | `getHostnameVerifier()` |
    `ClientHttpEngine` | `getHttpEngine()` |
    `KeyStore` | `getKeyStore()` |
    `String` | `getKeyStorePassword()` |
    `int` | `getMaxPooledPerRoute()` |
    `ResteasyProviderFactory` | `getProviderFactory()` |
    `long` | `getReadTimeout​(TimeUnit unit)` |
    `int` | `getResponseBufferSize()` |
    `List<String>` | `getSniHostNames()` |
    `SSLContext` | `getSSLContext()` |
    `KeyStore` | `getTrustStore()` |
    `ResteasyClientBuilderImpl` | `hostnameVerification​(ResteasyClientBuilder.HostnameVerificationPolicy policy)` | SSL policy used to verify hostnames
    `ResteasyClientBuilderImpl` | `hostnameVerifier​(HostnameVerifier verifier)` |
    `ResteasyClientBuilderImpl` | `httpEngine​(ClientHttpEngine httpEngine)` | Negates all ssl and connection specific configuration
    `boolean` | `isCookieManagementEnabled()` |
    `boolean` | `isDisableAutomaticRetries()` |
    `boolean` | `isFollowRedirects()` |
    `boolean` | `isTrustManagerDisabled()` |
    `boolean` | `isTrustSelfSignedCertificates()` |
    `boolean` | `isUseAsyncHttpEngine()` |
    `ResteasyClientBuilderImpl` | `keyStore​(KeyStore keyStore, char[] password)` |
    `ResteasyClientBuilderImpl` | `keyStore​(KeyStore keyStore, String password)` |
    `ResteasyClientBuilderImpl` | `maxPooledPerRoute​(int maxPooledPerRoute)` | If connection pooling enabled, how many connections to pool per url?
    `ResteasyClientBuilderImpl` | `property​(String name, Object value)` |
    `ResteasyClientBuilderImpl` | `providerFactory​(ResteasyProviderFactory providerFactory)` | Changing the providerFactory will wipe clean any registered components or properties.
    `ResteasyClientBuilderImpl` | `readTimeout​(long timeout, TimeUnit unit)` |
    `ResteasyClientBuilderImpl` | `register​(Class<?> componentClass)` |
    `ResteasyClientBuilderImpl` | `register​(Class<?> componentClass, int priority)` |
    `ResteasyClientBuilderImpl` | `register​(Class<?> componentClass, Class<?>... contracts)` |
    `ResteasyClientBuilderImpl` | `register​(Class<?> componentClass, Map<Class<?>,​Integer> contracts)` |
    `ResteasyClientBuilderImpl` | `register​(Object component)` |
    `ResteasyClientBuilderImpl` | `register​(Object component, int priority)` |
    `ResteasyClientBuilderImpl` | `register​(Object component, Class<?>... contracts)` |
    `ResteasyClientBuilderImpl` | `register​(Object component, Map<Class<?>,​Integer> contracts)` |
    `ResteasyClientBuilderImpl` | `responseBufferSize​(int size)` | Response stream is wrapped in a BufferedInputStream.
    `ResteasyClientBuilder` | `scheduledExecutorService​(ScheduledExecutorService scheduledExecutorService)` |
    `ResteasyClientBuilder` | `setFollowRedirects​(boolean followRedirects)` | Follow redirects added for MicroProfile-rest-client but can be used by tradition clients as well.
    `void` | `setIsTrustSelfSignedCertificates​(boolean b)` | When the user is not using a TrustManager (see disableTrustManager) and does not define an SSLContext object but they want all defined trustStores to use the TrustSelfSignedCertificates trust strategy set this value to true.
    `static void` | `setProviderFactory​(ResteasyProviderFactory providerFactory)` |
    `ResteasyClientBuilderImpl` | `sniHostNames​(String... sniHostNames)` | Adds a TLS/SSL SNI Host Name for authentication.
    `ResteasyClientBuilderImpl` | `sslContext​(SSLContext sslContext)` |
    `ResteasyClientBuilderImpl` | `trustStore​(KeyStore truststore)` |
    `ResteasyClientBuilderImpl` | `useAsyncHttpEngine()` |
    `ResteasyClientBuilderImpl` | `withConfig​(javax.ws.rs.core.Configuration config)` |

    - ### Methods inherited from class javax.ws.rs.client.ClientBuilder

      `newBuilder, newClient, newClient`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### truststore

          protected KeyStore truststore

    - #### clientKeyStore

          protected KeyStore clientKeyStore

    - #### clientPrivateKeyPassword

          protected String clientPrivateKeyPassword

    - #### disableTrustManager

          protected boolean disableTrustManager

    - #### policy

          protected ResteasyClientBuilder.HostnameVerificationPolicy policy

    - #### providerFactory

          protected ResteasyProviderFactory providerFactory

    - #### asyncExecutor

          protected ExecutorService asyncExecutor

    - #### scheduledExecutorService

          protected ScheduledExecutorService scheduledExecutorService

    - #### cleanupExecutor

          protected boolean cleanupExecutor

    - #### sslContext

          protected SSLContext sslContext

    - #### properties

          protected Map<String,​Object> properties

    - #### httpEngine

          protected ClientHttpEngine httpEngine

    - #### connectionPoolSize

          protected int connectionPoolSize

    - #### maxPooledPerRoute

          protected int maxPooledPerRoute

    - #### connectionTTL

          protected long connectionTTL

    - #### connectionTTLUnit

          protected TimeUnit connectionTTLUnit

    - #### socketTimeout

          protected long socketTimeout

    - #### socketTimeoutUnits

          protected TimeUnit socketTimeoutUnits

    - #### establishConnectionTimeout

          protected long establishConnectionTimeout

    - #### establishConnectionTimeoutUnits

          protected TimeUnit establishConnectionTimeoutUnits

    - #### connectionCheckoutTimeoutMs

          protected int connectionCheckoutTimeoutMs

    - #### verifier

          protected HostnameVerifier verifier

    - #### defaultProxy

          protected org.apache.http.HttpHost defaultProxy

    - #### responseBufferSize

          protected int responseBufferSize

    - #### sniHostNames

          protected List<String> sniHostNames

    - #### trustSelfSignedCertificates

          protected boolean trustSelfSignedCertificates

    - #### cookieManagementEnabled

          protected boolean cookieManagementEnabled

    - #### disableAutomaticRetries

          protected boolean disableAutomaticRetries

    - #### followRedirects

          protected boolean followRedirects

  - ### Constructor Detail

    - #### ResteasyClientBuilderImpl

          public ResteasyClientBuilderImpl()

  - ### Method Detail

    - #### setProviderFactory

          public static void setProviderFactory​(ResteasyProviderFactory providerFactory)

    - #### providerFactory

          public ResteasyClientBuilderImpl providerFactory​(ResteasyProviderFactory providerFactory)

      Changing the providerFactory will wipe clean any registered components or properties.
      Specified by:
        `providerFactory` in class `ResteasyClientBuilder`
      Parameters:
        `providerFactory` - provider factory
      Returns:
        the updated client builder instance

    - #### asyncExecutor

          @Deprecated
          public ResteasyClientBuilderImpl asyncExecutor​(ExecutorService asyncExecutor)

      Deprecated.
      use `executorService(ExecutorService)` instead
      Executor to use to run AsyncInvoker invocations.
      Parameters:
        `asyncExecutor` - executor service
      Returns:
        the updated client builder instance

    - #### asyncExecutor

          @Deprecated
          public ResteasyClientBuilderImpl asyncExecutor​(ExecutorService asyncExecutor,
                                                         boolean cleanupExecutor)

      Deprecated.
      Executor to use to run AsyncInvoker invocations.
      Parameters:
        `asyncExecutor` - executor service
        `cleanupExecutor` - true if the Client should close the executor when it is closed
      Returns:
        the updated client builder instance

    - #### connectionTTL

          public ResteasyClientBuilderImpl connectionTTL​(long ttl,
                                                         TimeUnit unit)

      If there is a connection pool, set the time to live in the pool.
      Specified by:
        `connectionTTL` in class `ResteasyClientBuilder`
      Parameters:
        `ttl` - time to live
        `unit` - the time unit of the ttl argument
      Returns:
        the updated client builder instance

    - #### readTimeout

          public ResteasyClientBuilderImpl readTimeout​(long timeout,
                                                       TimeUnit unit)

      Specified by:
        `readTimeout` in class `ResteasyClientBuilder`

    - #### connectTimeout

          public ResteasyClientBuilderImpl connectTimeout​(long timeout,
                                                          TimeUnit unit)

      Specified by:
        `connectTimeout` in class `ResteasyClientBuilder`

    - #### maxPooledPerRoute

          public ResteasyClientBuilderImpl maxPooledPerRoute​(int maxPooledPerRoute)

      If connection pooling enabled, how many connections to pool per url?
      Specified by:
        `maxPooledPerRoute` in class `ResteasyClientBuilder`
      Parameters:
        `maxPooledPerRoute` - max pool size per url
      Returns:
        the updated client builder instance

    - #### connectionCheckoutTimeout

          public ResteasyClientBuilderImpl connectionCheckoutTimeout​(long timeout,
                                                                     TimeUnit unit)

      If connection pooling is enabled, how long will we wait to get a connection?
      Specified by:
        `connectionCheckoutTimeout` in class `ResteasyClientBuilder`
      Parameters:
        `timeout` - the timeout
        `unit` - the units the timeout is in
      Returns:
        the updated client builder instance

    - #### connectionPoolSize

          public ResteasyClientBuilderImpl connectionPoolSize​(int connectionPoolSize)

      Number of connections allowed to pool.
      Specified by:
        `connectionPoolSize` in class `ResteasyClientBuilder`
      Parameters:
        `connectionPoolSize` - connection pool size
      Returns:
        the updated client builder instance

    - #### responseBufferSize

          public ResteasyClientBuilderImpl responseBufferSize​(int size)

      Response stream is wrapped in a BufferedInputStream. Default is 8192. Value of 0 will not wrap it. Value of -1 will use a SelfExpandingBufferedInputStream.
      Specified by:
        `responseBufferSize` in class `ResteasyClientBuilder`
      Parameters:
        `size` - response buffer size
      Returns:
        the updated client builder instance

    - #### disableTrustManager

          public ResteasyClientBuilderImpl disableTrustManager()

      Disable trust management and hostname verification. NOTE this is a security hole, so only set this option if you cannot or do not want to verify the identity of the host you are communicating with.
      Specified by:
        `disableTrustManager` in class `ResteasyClientBuilder`
      Returns:
        the updated client builder instance

    - #### hostnameVerification

          public ResteasyClientBuilderImpl hostnameVerification​(ResteasyClientBuilder.HostnameVerificationPolicy policy)

      SSL policy used to verify hostnames
      Specified by:
        `hostnameVerification` in class `ResteasyClientBuilder`
      Parameters:
        `policy` - SSL policy
      Returns:
        the updated client builder instance

    - #### httpEngine

          public ResteasyClientBuilderImpl httpEngine​(ClientHttpEngine httpEngine)

      Negates all ssl and connection specific configuration
      Specified by:
        `httpEngine` in class `ResteasyClientBuilder`
      Parameters:
        `httpEngine` - http engine
      Returns:
        the updated client builder instance

    - #### useAsyncHttpEngine

          public ResteasyClientBuilderImpl useAsyncHttpEngine()

      Specified by:
        `useAsyncHttpEngine` in class `ResteasyClientBuilder`

    - #### sslContext

          public ResteasyClientBuilderImpl sslContext​(SSLContext sslContext)

      Specified by:
        `sslContext` in class `ResteasyClientBuilder`

    - #### trustStore

          public ResteasyClientBuilderImpl trustStore​(KeyStore truststore)

      Specified by:
        `trustStore` in class `ResteasyClientBuilder`

    - #### keyStore

          public ResteasyClientBuilderImpl keyStore​(KeyStore keyStore,
                                                    String password)

      Specified by:
        `keyStore` in class `ResteasyClientBuilder`

    - #### keyStore

          public ResteasyClientBuilderImpl keyStore​(KeyStore keyStore,
                                                    char[] password)

      Specified by:
        `keyStore` in class `ResteasyClientBuilder`

    - #### property

          public ResteasyClientBuilderImpl property​(String name,
                                                    Object value)

    - #### sniHostNames

          public ResteasyClientBuilderImpl sniHostNames​(String... sniHostNames)

      Adds a TLS/SSL SNI Host Name for authentication.
      Specified by:
        `sniHostNames` in class `ResteasyClientBuilder`
      Parameters:
        `sniHostNames` - host names
      Returns:
        the updated client builder instance

    - #### defaultProxy

          public ResteasyClientBuilderImpl defaultProxy​(String hostname)

      Specify a default proxy. Default port and schema will be used.
      Specified by:
        `defaultProxy` in class `ResteasyClientBuilder`
      Parameters:
        `hostname` - host name
      Returns:
        the updated client builder instance

    - #### defaultProxy

          public ResteasyClientBuilderImpl defaultProxy​(String hostname,
                                                        int port)

      Specify a default proxy host and port. Default schema will be used.
      Specified by:
        `defaultProxy` in class `ResteasyClientBuilder`
      Parameters:
        `hostname` - host name
        `port` - port
      Returns:
        the updated client builder instance

    - #### defaultProxy

          public ResteasyClientBuilderImpl defaultProxy​(String hostname,
                                                        int port,
                                                        String scheme)

      Specify default proxy.
      Specified by:
        `defaultProxy` in class `ResteasyClientBuilder`
      Parameters:
        `hostname` - host name
        `port` - port
        `scheme` - scheme
      Returns:
        the updated client builder instance

    - #### getProviderFactory

          public ResteasyProviderFactory getProviderFactory()

      Specified by:
        `getProviderFactory` in class `ResteasyClientBuilder`

    - #### build

          public ResteasyClient build()

      Specified by:
        `build` in class `ResteasyClientBuilder`

    - #### createResteasyClient

          protected ResteasyClient createResteasyClient​(ClientHttpEngine engine,
                                                        ExecutorService executor,
                                                        boolean cleanupExecutor,
                                                        ScheduledExecutorService scheduledExecutorService,
                                                        ClientConfiguration config)

    - #### hostnameVerifier

          public ResteasyClientBuilderImpl hostnameVerifier​(HostnameVerifier verifier)

      Specified by:
        `hostnameVerifier` in class `ResteasyClientBuilder`

    - #### getConfiguration

          public javax.ws.rs.core.Configuration getConfiguration()

    - #### register

          public ResteasyClientBuilderImpl register​(Class<?> componentClass)

    - #### register

          public ResteasyClientBuilderImpl register​(Class<?> componentClass,
                                                    int priority)

    - #### register

          public ResteasyClientBuilderImpl register​(Class<?> componentClass,
                                                    Class<?>... contracts)

    - #### register

          public ResteasyClientBuilderImpl register​(Class<?> componentClass,
                                                    Map<Class<?>,​Integer> contracts)

    - #### register

          public ResteasyClientBuilderImpl register​(Object component)

    - #### register

          public ResteasyClientBuilderImpl register​(Object component,
                                                    int priority)

    - #### register

          public ResteasyClientBuilderImpl register​(Object component,
                                                    Class<?>... contracts)

    - #### register

          public ResteasyClientBuilderImpl register​(Object component,
                                                    Map<Class<?>,​Integer> contracts)

    - #### withConfig

          public ResteasyClientBuilderImpl withConfig​(javax.ws.rs.core.Configuration config)

      Specified by:
        `withConfig` in class `ResteasyClientBuilder`

    - #### executorService

          public ResteasyClientBuilder executorService​(ExecutorService executorService)

      Specified by:
        `executorService` in class `ResteasyClientBuilder`

    - #### executorService

          public ResteasyClientBuilder executorService​(ExecutorService executorService,
                                                       boolean cleanupExecutor)

      Specified by:
        `executorService` in class `ResteasyClientBuilder`

    - #### scheduledExecutorService

          public ResteasyClientBuilder scheduledExecutorService​(ScheduledExecutorService scheduledExecutorService)

      Specified by:
        `scheduledExecutorService` in class `ResteasyClientBuilder`

    - #### getConnectionTTL

          public long getConnectionTTL​(TimeUnit unit)

      Specified by:
        `getConnectionTTL` in class `ResteasyClientBuilder`

    - #### getMaxPooledPerRoute

          public int getMaxPooledPerRoute()

      Specified by:
        `getMaxPooledPerRoute` in class `ResteasyClientBuilder`

    - #### getConnectionCheckoutTimeout

          public long getConnectionCheckoutTimeout​(TimeUnit unit)

      Specified by:
        `getConnectionCheckoutTimeout` in class `ResteasyClientBuilder`

    - #### getConnectionPoolSize

          public int getConnectionPoolSize()

      Specified by:
        `getConnectionPoolSize` in class `ResteasyClientBuilder`

    - #### getResponseBufferSize

          public int getResponseBufferSize()

      Specified by:
        `getResponseBufferSize` in class `ResteasyClientBuilder`

    - #### isTrustManagerDisabled

          public boolean isTrustManagerDisabled()

      Specified by:
        `isTrustManagerDisabled` in class `ResteasyClientBuilder`

    - #### isTrustSelfSignedCertificates

          public boolean isTrustSelfSignedCertificates()

      Specified by:
        `isTrustSelfSignedCertificates` in class `ResteasyClientBuilder`

    - #### setIsTrustSelfSignedCertificates

          public void setIsTrustSelfSignedCertificates​(boolean b)

      Description copied from class: `ResteasyClientBuilder`
      When the user is not using a TrustManager (see disableTrustManager) and does not define an SSLContext object but they want all defined trustStores to use the TrustSelfSignedCertificates trust strategy set this value to true.
      Specified by:
        `setIsTrustSelfSignedCertificates` in class `ResteasyClientBuilder`
      Parameters:
        `b` - A value of true assigns trust strategy TrustSelfSignedCertificates to the trustStores. A value of false assigns a null to the trust strategy. The default value is true in order to maintain backward compatibility.

    - #### getHostnameVerification

          public ResteasyClientBuilder.HostnameVerificationPolicy getHostnameVerification()

      Specified by:
        `getHostnameVerification` in class `ResteasyClientBuilder`

    - #### getHttpEngine

          public ClientHttpEngine getHttpEngine()

      Specified by:
        `getHttpEngine` in class `ResteasyClientBuilder`

    - #### isUseAsyncHttpEngine

          public boolean isUseAsyncHttpEngine()

      Specified by:
        `isUseAsyncHttpEngine` in class `ResteasyClientBuilder`

    - #### getSniHostNames

          public List<String> getSniHostNames()

      Specified by:
        `getSniHostNames` in class `ResteasyClientBuilder`

    - #### getDefaultProxyHostname

          public String getDefaultProxyHostname()

      Specified by:
        `getDefaultProxyHostname` in class `ResteasyClientBuilder`

    - #### getDefaultProxyPort

          public int getDefaultProxyPort()

      Specified by:
        `getDefaultProxyPort` in class `ResteasyClientBuilder`

    - #### getDefaultProxyScheme

          public String getDefaultProxyScheme()

      Specified by:
        `getDefaultProxyScheme` in class `ResteasyClientBuilder`

    - #### getReadTimeout

          public long getReadTimeout​(TimeUnit unit)

      Specified by:
        `getReadTimeout` in class `ResteasyClientBuilder`

    - #### getConnectionTimeout

          public long getConnectionTimeout​(TimeUnit unit)

      Specified by:
        `getConnectionTimeout` in class `ResteasyClientBuilder`

    - #### getSSLContext

          public SSLContext getSSLContext()

      Specified by:
        `getSSLContext` in class `ResteasyClientBuilder`

    - #### getKeyStore

          public KeyStore getKeyStore()

      Specified by:
        `getKeyStore` in class `ResteasyClientBuilder`

    - #### getKeyStorePassword

          public String getKeyStorePassword()

      Specified by:
        `getKeyStorePassword` in class `ResteasyClientBuilder`

    - #### getTrustStore

          public KeyStore getTrustStore()

      Specified by:
        `getTrustStore` in class `ResteasyClientBuilder`

    - #### getHostnameVerifier

          public HostnameVerifier getHostnameVerifier()

      Specified by:
        `getHostnameVerifier` in class `ResteasyClientBuilder`

    - #### enableCookieManagement

          public ResteasyClientBuilder enableCookieManagement()

      Description copied from class: `ResteasyClientBuilder`
      Enable state (cookie) management.
      Specified by:
        `enableCookieManagement` in class `ResteasyClientBuilder`
      Returns:
        the updated client builder instance

    - #### isCookieManagementEnabled

          public boolean isCookieManagementEnabled()

      Specified by:
        `isCookieManagementEnabled` in class `ResteasyClientBuilder`

    - #### disableAutomaticRetries

          public ResteasyClientBuilder disableAutomaticRetries()

      Description copied from class: `ResteasyClientBuilder`
      boolean, notify apache to disable its automatic retries.
      Specified by:
        `disableAutomaticRetries` in class `ResteasyClientBuilder`

    - #### isDisableAutomaticRetries

          public boolean isDisableAutomaticRetries()

      Specified by:
        `isDisableAutomaticRetries` in class `ResteasyClientBuilder`

    - #### setFollowRedirects

          public ResteasyClientBuilder setFollowRedirects​(boolean followRedirects)

      Description copied from class: `ResteasyClientBuilder`
      Follow redirects added for MicroProfile-rest-client but can be used by tradition clients as well.
      Specified by:
        `setFollowRedirects` in class `ResteasyClientBuilder`
      Returns:

    - #### isFollowRedirects

          public boolean isFollowRedirects()

      Specified by:
        `isFollowRedirects` in class `ResteasyClientBuilder`